/* Themes.c generated by valac 0.56.14, the Vala compiler
 * generated from Themes.vala, do not modify */

/*
* Copyright 2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License version 3, as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>

#define TERMINAL_THEMES_DARK "dark"
#define TERMINAL_THEMES_HIGH_CONTRAST "high-contrast"
#define TERMINAL_THEMES_LIGHT "solarized-light"
#define TERMINAL_THEMES_CUSTOM "custom"
#define TERMINAL_THEMES_PALETTE_SIZE 19
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINAL_TYPE_THEMES (terminal_themes_get_type ())
#define TERMINAL_THEMES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_THEMES, TerminalThemes))
#define TERMINAL_THEMES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_THEMES, TerminalThemesClass))
#define TERMINAL_IS_THEMES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_THEMES))
#define TERMINAL_IS_THEMES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_THEMES))
#define TERMINAL_THEMES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_THEMES, TerminalThemesClass))

typedef struct _TerminalThemes TerminalThemes;
typedef struct _TerminalThemesClass TerminalThemesClass;
typedef struct _TerminalThemesPrivate TerminalThemesPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _TerminalParamSpecThemes TerminalParamSpecThemes;

struct _TerminalThemes {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TerminalThemesPrivate * priv;
};

struct _TerminalThemesClass {
	GTypeClass parent_class;
	void (*finalize) (TerminalThemes *self);
};

struct _TerminalParamSpecThemes {
	GParamSpec parent_instance;
};

static gpointer terminal_themes_parent_class = NULL;
VALA_EXTERN GSettings* terminal_application_settings;

VALA_EXTERN gpointer terminal_themes_ref (gpointer instance);
VALA_EXTERN void terminal_themes_unref (gpointer instance);
VALA_EXTERN GParamSpec* terminal_param_spec_themes (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void terminal_value_set_themes (GValue* value,
                                gpointer v_object);
VALA_EXTERN void terminal_value_take_themes (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer terminal_value_get_themes (const GValue* value);
VALA_EXTERN GType terminal_themes_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalThemes, terminal_themes_unref)
VALA_EXTERN GdkRGBA* terminal_themes_get_rgba_palette (const gchar* theme,
                                           gint* result_length1);
static gchar** terminal_themes_get_string_palette (const gchar* theme,
                                            gint* result_length1);
static void _vala_array_add13 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add14 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add15 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN TerminalThemes* terminal_themes_new (void);
VALA_EXTERN TerminalThemes* terminal_themes_construct (GType object_type);
static void _terminal_themes___lambda4_ (void);
static void __terminal_themes___lambda4__g_settings_changed (GSettings* _sender,
                                                      const gchar* key,
                                                      gpointer self);
static void terminal_themes_finalize (TerminalThemes * obj);
static GType terminal_themes_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 142 "Themes.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 146 "Themes.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 152 "Themes.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 157 "Themes.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 163 "Themes.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 167 "Themes.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 171 "Themes.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 175 "Themes.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 179 "Themes.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 183 "Themes.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 198 "Themes.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 207 "Themes.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 214 "Themes.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 220 "Themes.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 228 "Themes.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 232 "Themes.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 238 "Themes.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 243 "Themes.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 249 "Themes.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 253 "Themes.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 257 "Themes.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 263 "Themes.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 269 "Themes.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 281 "Themes.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 285 "Themes.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 289 "Themes.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 294 "Themes.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 302 "Themes.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 320 "Themes.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 326 "Themes.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 330 "Themes.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 338 "Themes.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 347 "Themes.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 356 "Themes.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 362 "Themes.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 370 "Themes.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 382 "Themes.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 388 "Themes.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 392 "Themes.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 400 "Themes.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 411 "Themes.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 420 "Themes.c"
	}
}

GdkRGBA*
terminal_themes_get_rgba_palette (const gchar* theme,
                                  gint* result_length1)
{
	gchar** string_palette = NULL;
	gint _tmp0_ = 0;
	gchar** _tmp1_;
	gint string_palette_length1;
	gint _string_palette_size_;
	gboolean settings_valid = FALSE;
	gchar** _tmp2_;
	gint _tmp2__length1;
	GdkRGBA* rgba_palette = NULL;
	GdkRGBA* _tmp3_;
	gint rgba_palette_length1;
	gint _rgba_palette_size_;
	GdkRGBA* _tmp26_;
	gint _tmp26__length1;
	GdkRGBA* result;
#line 43 "../src/Themes.vala"
	g_return_val_if_fail (theme != NULL, NULL);
#line 44 "../src/Themes.vala"
	_tmp1_ = terminal_themes_get_string_palette (theme, &_tmp0_);
#line 44 "../src/Themes.vala"
	string_palette = _tmp1_;
#line 44 "../src/Themes.vala"
	string_palette_length1 = _tmp0_;
#line 44 "../src/Themes.vala"
	_string_palette_size_ = string_palette_length1;
#line 45 "../src/Themes.vala"
	_tmp2_ = string_palette;
#line 45 "../src/Themes.vala"
	_tmp2__length1 = string_palette_length1;
#line 45 "../src/Themes.vala"
	settings_valid = _tmp2__length1 == TERMINAL_THEMES_PALETTE_SIZE;
#line 47 "../src/Themes.vala"
	_tmp3_ = g_new0 (GdkRGBA, TERMINAL_THEMES_PALETTE_SIZE);
#line 47 "../src/Themes.vala"
	rgba_palette = _tmp3_;
#line 47 "../src/Themes.vala"
	rgba_palette_length1 = TERMINAL_THEMES_PALETTE_SIZE;
#line 47 "../src/Themes.vala"
	_rgba_palette_size_ = rgba_palette_length1;
#line 467 "Themes.c"
	{
		gint i = 0;
#line 48 "../src/Themes.vala"
		i = 0;
#line 472 "Themes.c"
		{
			gboolean _tmp4_ = FALSE;
#line 48 "../src/Themes.vala"
			_tmp4_ = TRUE;
#line 48 "../src/Themes.vala"
			while (TRUE) {
#line 479 "Themes.c"
				GdkRGBA new_color = {0};
				gchar** _tmp6_;
				gint _tmp6__length1;
				const gchar* _tmp7_;
				GdkRGBA* _tmp20_;
				gint _tmp20__length1;
				GdkRGBA _tmp21_;
#line 48 "../src/Themes.vala"
				if (!_tmp4_) {
#line 489 "Themes.c"
					gint _tmp5_;
#line 48 "../src/Themes.vala"
					_tmp5_ = i;
#line 48 "../src/Themes.vala"
					i = _tmp5_ + 1;
#line 495 "Themes.c"
				}
#line 48 "../src/Themes.vala"
				_tmp4_ = FALSE;
#line 48 "../src/Themes.vala"
				if (!(i < TERMINAL_THEMES_PALETTE_SIZE)) {
#line 48 "../src/Themes.vala"
					break;
#line 503 "Themes.c"
				}
#line 49 "../src/Themes.vala"
				memset (&new_color, 0, sizeof (GdkRGBA));
#line 51 "../src/Themes.vala"
				_tmp6_ = string_palette;
#line 51 "../src/Themes.vala"
				_tmp6__length1 = string_palette_length1;
#line 51 "../src/Themes.vala"
				_tmp7_ = _tmp6_[i];
#line 51 "../src/Themes.vala"
				if (!gdk_rgba_parse (&new_color, _tmp7_)) {
#line 515 "Themes.c"
					gchar** _tmp8_;
					gint _tmp8__length1;
					const gchar* _tmp9_;
					const gchar* _tmp10_ = NULL;
					GSettings* _tmp11_;
					gchar** fallback_palette = NULL;
					gint _tmp12_ = 0;
					gchar** _tmp13_;
					gint fallback_palette_length1;
					gint _fallback_palette_size_;
					gchar** _tmp14_;
					gint _tmp14__length1;
					gchar** _tmp15_;
					gint _tmp15__length1;
					const gchar* _tmp16_;
					gchar* _tmp17_;
					gchar** _tmp18_;
					gint _tmp18__length1;
					const gchar* _tmp19_;
#line 52 "../src/Themes.vala"
					_tmp8_ = string_palette;
#line 52 "../src/Themes.vala"
					_tmp8__length1 = string_palette_length1;
#line 52 "../src/Themes.vala"
					_tmp9_ = _tmp8_[i];
#line 52 "../src/Themes.vala"
					g_critical ("Themes.vala:52: Color %i '%s' is not valid - replacing with default", i, _tmp9_);
#line 53 "../src/Themes.vala"
					settings_valid = FALSE;
#line 56 "../src/Themes.vala"
					_tmp11_ = terminal_application_settings;
#line 56 "../src/Themes.vala"
					if (g_settings_get_boolean (_tmp11_, "prefer-dark-style")) {
#line 56 "../src/Themes.vala"
						_tmp10_ = TERMINAL_THEMES_DARK;
#line 551 "Themes.c"
					} else {
#line 56 "../src/Themes.vala"
						_tmp10_ = TERMINAL_THEMES_LIGHT;
#line 555 "Themes.c"
					}
#line 55 "../src/Themes.vala"
					_tmp13_ = terminal_themes_get_string_palette (_tmp10_, &_tmp12_);
#line 55 "../src/Themes.vala"
					fallback_palette = _tmp13_;
#line 55 "../src/Themes.vala"
					fallback_palette_length1 = _tmp12_;
#line 55 "../src/Themes.vala"
					_fallback_palette_size_ = fallback_palette_length1;
#line 58 "../src/Themes.vala"
					_tmp14_ = string_palette;
#line 58 "../src/Themes.vala"
					_tmp14__length1 = string_palette_length1;
#line 58 "../src/Themes.vala"
					_tmp15_ = fallback_palette;
#line 58 "../src/Themes.vala"
					_tmp15__length1 = fallback_palette_length1;
#line 58 "../src/Themes.vala"
					_tmp16_ = _tmp15_[i];
#line 58 "../src/Themes.vala"
					_tmp17_ = g_strdup (_tmp16_);
#line 58 "../src/Themes.vala"
					_g_free0 (_tmp14_[i]);
#line 58 "../src/Themes.vala"
					_tmp14_[i] = _tmp17_;
#line 59 "../src/Themes.vala"
					_tmp18_ = fallback_palette;
#line 59 "../src/Themes.vala"
					_tmp18__length1 = fallback_palette_length1;
#line 59 "../src/Themes.vala"
					_tmp19_ = _tmp18_[i];
#line 59 "../src/Themes.vala"
					gdk_rgba_parse (&new_color, _tmp19_);
#line 51 "../src/Themes.vala"
					fallback_palette = (_vala_array_free (fallback_palette, fallback_palette_length1, (GDestroyNotify) g_free), NULL);
#line 591 "Themes.c"
				}
#line 62 "../src/Themes.vala"
				_tmp20_ = rgba_palette;
#line 62 "../src/Themes.vala"
				_tmp20__length1 = rgba_palette_length1;
#line 62 "../src/Themes.vala"
				_tmp21_ = new_color;
#line 62 "../src/Themes.vala"
				_tmp20_[i] = _tmp21_;
#line 601 "Themes.c"
			}
		}
	}
#line 65 "../src/Themes.vala"
	if (!settings_valid) {
#line 607 "Themes.c"
		GSettings* _tmp22_;
		gchar** _tmp23_;
		gint _tmp23__length1;
		gchar* _tmp24_;
		gchar* _tmp25_;
#line 67 "../src/Themes.vala"
		_tmp22_ = terminal_application_settings;
#line 67 "../src/Themes.vala"
		_tmp23_ = string_palette;
#line 67 "../src/Themes.vala"
		_tmp23__length1 = string_palette_length1;
#line 67 "../src/Themes.vala"
		_tmp24_ = _vala_g_strjoinv (":", _tmp23_, (gint) _tmp23__length1);
#line 67 "../src/Themes.vala"
		_tmp25_ = _tmp24_;
#line 67 "../src/Themes.vala"
		g_settings_set_string (_tmp22_, "palette", _tmp25_);
#line 67 "../src/Themes.vala"
		_g_free0 (_tmp25_);
#line 627 "Themes.c"
	}
#line 70 "../src/Themes.vala"
	_tmp26_ = rgba_palette;
#line 70 "../src/Themes.vala"
	_tmp26__length1 = rgba_palette_length1;
#line 70 "../src/Themes.vala"
	if (result_length1) {
#line 70 "../src/Themes.vala"
		*result_length1 = _tmp26__length1;
#line 637 "Themes.c"
	}
#line 70 "../src/Themes.vala"
	result = _tmp26_;
#line 70 "../src/Themes.vala"
	string_palette = (_vala_array_free (string_palette, string_palette_length1, (GDestroyNotify) g_free), NULL);
#line 70 "../src/Themes.vala"
	return result;
#line 645 "Themes.c"
}

static void
_vala_array_add13 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 99 "../src/Themes.vala"
	if ((*length) == (*size)) {
#line 99 "../src/Themes.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 99 "../src/Themes.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 660 "Themes.c"
	}
#line 99 "../src/Themes.vala"
	(*array)[(*length)++] = value;
#line 99 "../src/Themes.vala"
	(*array)[*length] = NULL;
#line 666 "Themes.c"
}

static void
_vala_array_add14 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 100 "../src/Themes.vala"
	if ((*length) == (*size)) {
#line 100 "../src/Themes.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 100 "../src/Themes.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 681 "Themes.c"
	}
#line 100 "../src/Themes.vala"
	(*array)[(*length)++] = value;
#line 100 "../src/Themes.vala"
	(*array)[*length] = NULL;
#line 687 "Themes.c"
}

static void
_vala_array_add15 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 101 "../src/Themes.vala"
	if ((*length) == (*size)) {
#line 101 "../src/Themes.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 101 "../src/Themes.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 702 "Themes.c"
	}
#line 101 "../src/Themes.vala"
	(*array)[(*length)++] = value;
#line 101 "../src/Themes.vala"
	(*array)[*length] = NULL;
#line 708 "Themes.c"
}

static gchar**
terminal_themes_get_string_palette (const gchar* theme,
                                    gint* result_length1)
{
	gchar** string_palette = NULL;
	gchar** _tmp0_;
	gint string_palette_length1;
	gint _string_palette_size_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 75 "../src/Themes.vala"
	static GQuark _tmp2_label0 = 0;
#line 75 "../src/Themes.vala"
	static GQuark _tmp2_label1 = 0;
#line 75 "../src/Themes.vala"
	static GQuark _tmp2_label2 = 0;
#line 75 "../src/Themes.vala"
	static GQuark _tmp2_label3 = 0;
#line 729 "Themes.c"
	gchar** _tmp75_;
	gint _tmp75__length1;
	gchar** result;
#line 73 "../src/Themes.vala"
	g_return_val_if_fail (theme != NULL, NULL);
#line 74 "../src/Themes.vala"
	_tmp0_ = g_new0 (gchar*, TERMINAL_THEMES_PALETTE_SIZE + 1);
#line 74 "../src/Themes.vala"
	string_palette = _tmp0_;
#line 74 "../src/Themes.vala"
	string_palette_length1 = TERMINAL_THEMES_PALETTE_SIZE;
#line 74 "../src/Themes.vala"
	_string_palette_size_ = string_palette_length1;
#line 75 "../src/Themes.vala"
	_tmp1_ = theme;
#line 75 "../src/Themes.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 75 "../src/Themes.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string (TERMINAL_THEMES_HIGH_CONTRAST)))) {
#line 75 "../src/Themes.vala"
		switch (0) {
#line 751 "Themes.c"
			default:
			{
				gchar* _tmp4_;
				gchar* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				gchar** _tmp23_;
#line 77 "../src/Themes.vala"
				_tmp4_ = g_strdup ("#073642");
#line 77 "../src/Themes.vala"
				_tmp5_ = g_strdup ("#dc322f");
#line 77 "../src/Themes.vala"
				_tmp6_ = g_strdup ("#859900");
#line 77 "../src/Themes.vala"
				_tmp7_ = g_strdup ("#b58900");
#line 77 "../src/Themes.vala"
				_tmp8_ = g_strdup ("#268bd2");
#line 77 "../src/Themes.vala"
				_tmp9_ = g_strdup ("#d33682");
#line 77 "../src/Themes.vala"
				_tmp10_ = g_strdup ("#2aa198");
#line 77 "../src/Themes.vala"
				_tmp11_ = g_strdup ("#eee8d5");
#line 77 "../src/Themes.vala"
				_tmp12_ = g_strdup ("#002b36");
#line 77 "../src/Themes.vala"
				_tmp13_ = g_strdup ("#dc322f");
#line 77 "../src/Themes.vala"
				_tmp14_ = g_strdup ("#586e75");
#line 77 "../src/Themes.vala"
				_tmp15_ = g_strdup ("#657b83");
#line 77 "../src/Themes.vala"
				_tmp16_ = g_strdup ("#839496");
#line 77 "../src/Themes.vala"
				_tmp17_ = g_strdup ("#6c71c4");
#line 77 "../src/Themes.vala"
				_tmp18_ = g_strdup ("#93a1a1");
#line 77 "../src/Themes.vala"
				_tmp19_ = g_strdup ("#fdf6e3");
#line 77 "../src/Themes.vala"
				_tmp20_ = g_strdup ("#ffffff");
#line 77 "../src/Themes.vala"
				_tmp21_ = g_strdup ("#333333");
#line 77 "../src/Themes.vala"
				_tmp22_ = g_strdup ("#839496");
#line 77 "../src/Themes.vala"
				_tmp23_ = g_new0 (gchar*, 19 + 1);
#line 77 "../src/Themes.vala"
				_tmp23_[0] = _tmp4_;
#line 77 "../src/Themes.vala"
				_tmp23_[1] = _tmp5_;
#line 77 "../src/Themes.vala"
				_tmp23_[2] = _tmp6_;
#line 77 "../src/Themes.vala"
				_tmp23_[3] = _tmp7_;
#line 77 "../src/Themes.vala"
				_tmp23_[4] = _tmp8_;
#line 77 "../src/Themes.vala"
				_tmp23_[5] = _tmp9_;
#line 77 "../src/Themes.vala"
				_tmp23_[6] = _tmp10_;
#line 77 "../src/Themes.vala"
				_tmp23_[7] = _tmp11_;
#line 77 "../src/Themes.vala"
				_tmp23_[8] = _tmp12_;
#line 77 "../src/Themes.vala"
				_tmp23_[9] = _tmp13_;
#line 77 "../src/Themes.vala"
				_tmp23_[10] = _tmp14_;
#line 77 "../src/Themes.vala"
				_tmp23_[11] = _tmp15_;
#line 77 "../src/Themes.vala"
				_tmp23_[12] = _tmp16_;
#line 77 "../src/Themes.vala"
				_tmp23_[13] = _tmp17_;
#line 77 "../src/Themes.vala"
				_tmp23_[14] = _tmp18_;
#line 77 "../src/Themes.vala"
				_tmp23_[15] = _tmp19_;
#line 77 "../src/Themes.vala"
				_tmp23_[16] = _tmp20_;
#line 77 "../src/Themes.vala"
				_tmp23_[17] = _tmp21_;
#line 77 "../src/Themes.vala"
				_tmp23_[18] = _tmp22_;
#line 77 "../src/Themes.vala"
				string_palette = (_vala_array_free (string_palette, string_palette_length1, (GDestroyNotify) g_free), NULL);
#line 77 "../src/Themes.vala"
				string_palette = _tmp23_;
#line 77 "../src/Themes.vala"
				string_palette_length1 = 19;
#line 77 "../src/Themes.vala"
				_string_palette_size_ = string_palette_length1;
#line 82 "../src/Themes.vala"
				break;
#line 862 "Themes.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string (TERMINAL_THEMES_LIGHT)))) {
#line 75 "../src/Themes.vala"
		switch (0) {
#line 868 "Themes.c"
			default:
			{
				gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				gchar** _tmp43_;
#line 84 "../src/Themes.vala"
				_tmp24_ = g_strdup ("#073642");
#line 84 "../src/Themes.vala"
				_tmp25_ = g_strdup ("#dc322f");
#line 84 "../src/Themes.vala"
				_tmp26_ = g_strdup ("#859900");
#line 84 "../src/Themes.vala"
				_tmp27_ = g_strdup ("#b58900");
#line 84 "../src/Themes.vala"
				_tmp28_ = g_strdup ("#268bd2");
#line 84 "../src/Themes.vala"
				_tmp29_ = g_strdup ("#d33682");
#line 84 "../src/Themes.vala"
				_tmp30_ = g_strdup ("#2aa198");
#line 84 "../src/Themes.vala"
				_tmp31_ = g_strdup ("#eee8d5");
#line 84 "../src/Themes.vala"
				_tmp32_ = g_strdup ("#002b36");
#line 84 "../src/Themes.vala"
				_tmp33_ = g_strdup ("#dc322f");
#line 84 "../src/Themes.vala"
				_tmp34_ = g_strdup ("#586e75");
#line 84 "../src/Themes.vala"
				_tmp35_ = g_strdup ("#657b83");
#line 84 "../src/Themes.vala"
				_tmp36_ = g_strdup ("#839496");
#line 84 "../src/Themes.vala"
				_tmp37_ = g_strdup ("#6c71c4");
#line 84 "../src/Themes.vala"
				_tmp38_ = g_strdup ("#93a1a1");
#line 84 "../src/Themes.vala"
				_tmp39_ = g_strdup ("#fdf6e3");
#line 84 "../src/Themes.vala"
				_tmp40_ = g_strdup ("#FDF6E3");
#line 84 "../src/Themes.vala"
				_tmp41_ = g_strdup ("#586e75");
#line 84 "../src/Themes.vala"
				_tmp42_ = g_strdup ("#839496");
#line 84 "../src/Themes.vala"
				_tmp43_ = g_new0 (gchar*, 19 + 1);
#line 84 "../src/Themes.vala"
				_tmp43_[0] = _tmp24_;
#line 84 "../src/Themes.vala"
				_tmp43_[1] = _tmp25_;
#line 84 "../src/Themes.vala"
				_tmp43_[2] = _tmp26_;
#line 84 "../src/Themes.vala"
				_tmp43_[3] = _tmp27_;
#line 84 "../src/Themes.vala"
				_tmp43_[4] = _tmp28_;
#line 84 "../src/Themes.vala"
				_tmp43_[5] = _tmp29_;
#line 84 "../src/Themes.vala"
				_tmp43_[6] = _tmp30_;
#line 84 "../src/Themes.vala"
				_tmp43_[7] = _tmp31_;
#line 84 "../src/Themes.vala"
				_tmp43_[8] = _tmp32_;
#line 84 "../src/Themes.vala"
				_tmp43_[9] = _tmp33_;
#line 84 "../src/Themes.vala"
				_tmp43_[10] = _tmp34_;
#line 84 "../src/Themes.vala"
				_tmp43_[11] = _tmp35_;
#line 84 "../src/Themes.vala"
				_tmp43_[12] = _tmp36_;
#line 84 "../src/Themes.vala"
				_tmp43_[13] = _tmp37_;
#line 84 "../src/Themes.vala"
				_tmp43_[14] = _tmp38_;
#line 84 "../src/Themes.vala"
				_tmp43_[15] = _tmp39_;
#line 84 "../src/Themes.vala"
				_tmp43_[16] = _tmp40_;
#line 84 "../src/Themes.vala"
				_tmp43_[17] = _tmp41_;
#line 84 "../src/Themes.vala"
				_tmp43_[18] = _tmp42_;
#line 84 "../src/Themes.vala"
				string_palette = (_vala_array_free (string_palette, string_palette_length1, (GDestroyNotify) g_free), NULL);
#line 84 "../src/Themes.vala"
				string_palette = _tmp43_;
#line 84 "../src/Themes.vala"
				string_palette_length1 = 19;
#line 84 "../src/Themes.vala"
				_string_palette_size_ = string_palette_length1;
#line 89 "../src/Themes.vala"
				break;
#line 979 "Themes.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string (TERMINAL_THEMES_DARK)))) {
#line 75 "../src/Themes.vala"
		switch (0) {
#line 985 "Themes.c"
			default:
			{
				gchar* _tmp44_;
				gchar* _tmp45_;
				gchar* _tmp46_;
				gchar* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
				gchar* _tmp53_;
				gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
				gchar* _tmp57_;
				gchar* _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
				gchar* _tmp61_;
				gchar* _tmp62_;
				gchar** _tmp63_;
#line 91 "../src/Themes.vala"
				_tmp44_ = g_strdup ("#073642");
#line 91 "../src/Themes.vala"
				_tmp45_ = g_strdup ("#dc322f");
#line 91 "../src/Themes.vala"
				_tmp46_ = g_strdup ("#859900");
#line 91 "../src/Themes.vala"
				_tmp47_ = g_strdup ("#b58900");
#line 91 "../src/Themes.vala"
				_tmp48_ = g_strdup ("#268bd2");
#line 91 "../src/Themes.vala"
				_tmp49_ = g_strdup ("#d33682");
#line 91 "../src/Themes.vala"
				_tmp50_ = g_strdup ("#2aa198");
#line 91 "../src/Themes.vala"
				_tmp51_ = g_strdup ("#eee8d5");
#line 91 "../src/Themes.vala"
				_tmp52_ = g_strdup ("#002b36");
#line 91 "../src/Themes.vala"
				_tmp53_ = g_strdup ("#dc322f");
#line 91 "../src/Themes.vala"
				_tmp54_ = g_strdup ("#586e75");
#line 91 "../src/Themes.vala"
				_tmp55_ = g_strdup ("#657b83");
#line 91 "../src/Themes.vala"
				_tmp56_ = g_strdup ("#839496");
#line 91 "../src/Themes.vala"
				_tmp57_ = g_strdup ("#6c71c4");
#line 91 "../src/Themes.vala"
				_tmp58_ = g_strdup ("#93a1a1");
#line 91 "../src/Themes.vala"
				_tmp59_ = g_strdup ("#fdf6e3");
#line 91 "../src/Themes.vala"
				_tmp60_ = g_strdup ("#2E2E2E");
#line 91 "../src/Themes.vala"
				_tmp61_ = g_strdup ("#a5a5a5");
#line 91 "../src/Themes.vala"
				_tmp62_ = g_strdup ("#839496");
#line 91 "../src/Themes.vala"
				_tmp63_ = g_new0 (gchar*, 19 + 1);
#line 91 "../src/Themes.vala"
				_tmp63_[0] = _tmp44_;
#line 91 "../src/Themes.vala"
				_tmp63_[1] = _tmp45_;
#line 91 "../src/Themes.vala"
				_tmp63_[2] = _tmp46_;
#line 91 "../src/Themes.vala"
				_tmp63_[3] = _tmp47_;
#line 91 "../src/Themes.vala"
				_tmp63_[4] = _tmp48_;
#line 91 "../src/Themes.vala"
				_tmp63_[5] = _tmp49_;
#line 91 "../src/Themes.vala"
				_tmp63_[6] = _tmp50_;
#line 91 "../src/Themes.vala"
				_tmp63_[7] = _tmp51_;
#line 91 "../src/Themes.vala"
				_tmp63_[8] = _tmp52_;
#line 91 "../src/Themes.vala"
				_tmp63_[9] = _tmp53_;
#line 91 "../src/Themes.vala"
				_tmp63_[10] = _tmp54_;
#line 91 "../src/Themes.vala"
				_tmp63_[11] = _tmp55_;
#line 91 "../src/Themes.vala"
				_tmp63_[12] = _tmp56_;
#line 91 "../src/Themes.vala"
				_tmp63_[13] = _tmp57_;
#line 91 "../src/Themes.vala"
				_tmp63_[14] = _tmp58_;
#line 91 "../src/Themes.vala"
				_tmp63_[15] = _tmp59_;
#line 91 "../src/Themes.vala"
				_tmp63_[16] = _tmp60_;
#line 91 "../src/Themes.vala"
				_tmp63_[17] = _tmp61_;
#line 91 "../src/Themes.vala"
				_tmp63_[18] = _tmp62_;
#line 91 "../src/Themes.vala"
				string_palette = (_vala_array_free (string_palette, string_palette_length1, (GDestroyNotify) g_free), NULL);
#line 91 "../src/Themes.vala"
				string_palette = _tmp63_;
#line 91 "../src/Themes.vala"
				string_palette_length1 = 19;
#line 91 "../src/Themes.vala"
				_string_palette_size_ = string_palette_length1;
#line 96 "../src/Themes.vala"
				break;
#line 1096 "Themes.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string (TERMINAL_THEMES_CUSTOM)))) {
#line 75 "../src/Themes.vala"
		switch (0) {
#line 1102 "Themes.c"
			default:
			{
				GSettings* _tmp64_;
				gchar* _tmp65_;
				gchar* _tmp66_;
				gchar** _tmp67_;
				gchar** _tmp68_;
				GSettings* _tmp69_;
				gchar* _tmp70_;
				GSettings* _tmp71_;
				gchar* _tmp72_;
				GSettings* _tmp73_;
				gchar* _tmp74_;
#line 98 "../src/Themes.vala"
				_tmp64_ = terminal_application_settings;
#line 98 "../src/Themes.vala"
				_tmp65_ = g_settings_get_string (_tmp64_, "palette");
#line 98 "../src/Themes.vala"
				_tmp66_ = _tmp65_;
#line 98 "../src/Themes.vala"
				_tmp68_ = _tmp67_ = g_strsplit (_tmp66_, ":", 0);
#line 98 "../src/Themes.vala"
				string_palette = (_vala_array_free (string_palette, string_palette_length1, (GDestroyNotify) g_free), NULL);
#line 98 "../src/Themes.vala"
				string_palette = _tmp68_;
#line 98 "../src/Themes.vala"
				string_palette_length1 = _vala_array_length (_tmp67_);
#line 98 "../src/Themes.vala"
				_string_palette_size_ = string_palette_length1;
#line 98 "../src/Themes.vala"
				_g_free0 (_tmp66_);
#line 99 "../src/Themes.vala"
				_tmp69_ = terminal_application_settings;
#line 99 "../src/Themes.vala"
				_tmp70_ = g_settings_get_string (_tmp69_, "background");
#line 99 "../src/Themes.vala"
				_vala_array_add13 (&string_palette, &string_palette_length1, &_string_palette_size_, _tmp70_);
#line 100 "../src/Themes.vala"
				_tmp71_ = terminal_application_settings;
#line 100 "../src/Themes.vala"
				_tmp72_ = g_settings_get_string (_tmp71_, "foreground");
#line 100 "../src/Themes.vala"
				_vala_array_add14 (&string_palette, &string_palette_length1, &_string_palette_size_, _tmp72_);
#line 101 "../src/Themes.vala"
				_tmp73_ = terminal_application_settings;
#line 101 "../src/Themes.vala"
				_tmp74_ = g_settings_get_string (_tmp73_, "cursor-color");
#line 101 "../src/Themes.vala"
				_vala_array_add15 (&string_palette, &string_palette_length1, &_string_palette_size_, _tmp74_);
#line 102 "../src/Themes.vala"
				break;
#line 1154 "Themes.c"
			}
		}
	}
#line 105 "../src/Themes.vala"
	_tmp75_ = string_palette;
#line 105 "../src/Themes.vala"
	_tmp75__length1 = string_palette_length1;
#line 105 "../src/Themes.vala"
	if (result_length1) {
#line 105 "../src/Themes.vala"
		*result_length1 = _tmp75__length1;
#line 1166 "Themes.c"
	}
#line 105 "../src/Themes.vala"
	result = _tmp75_;
#line 105 "../src/Themes.vala"
	return result;
#line 1172 "Themes.c"
}

TerminalThemes*
terminal_themes_construct (GType object_type)
{
	TerminalThemes* self = NULL;
#line 19 "../src/Themes.vala"
	self = (TerminalThemes*) g_type_create_instance (object_type);
#line 19 "../src/Themes.vala"
	return self;
#line 1183 "Themes.c"
}

TerminalThemes*
terminal_themes_new (void)
{
#line 19 "../src/Themes.vala"
	return terminal_themes_construct (TERMINAL_TYPE_THEMES);
#line 1191 "Themes.c"
}

static void
_terminal_themes___lambda4_ (void)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
#line 28 "../src/Themes.vala"
	static GQuark _tmp3_label0 = 0;
#line 28 "../src/Themes.vala"
	static GQuark _tmp3_label1 = 0;
#line 28 "../src/Themes.vala"
	static GQuark _tmp3_label2 = 0;
#line 28 "../src/Themes.vala"
	_tmp0_ = terminal_application_settings;
#line 28 "../src/Themes.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "theme");
#line 28 "../src/Themes.vala"
	_tmp2_ = _tmp1_;
#line 28 "../src/Themes.vala"
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
#line 28 "../src/Themes.vala"
	g_free (_tmp2_);
#line 28 "../src/Themes.vala"
	if (_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string (TERMINAL_THEMES_HIGH_CONTRAST)))) {
#line 28 "../src/Themes.vala"
		switch (0) {
#line 1221 "Themes.c"
			default:
			{
				GSettings* _tmp5_;
#line 30 "../src/Themes.vala"
				_tmp5_ = terminal_application_settings;
#line 30 "../src/Themes.vala"
				g_settings_set_boolean (_tmp5_, "prefer-dark-style", FALSE);
#line 31 "../src/Themes.vala"
				break;
#line 1231 "Themes.c"
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string (TERMINAL_THEMES_LIGHT)))) {
#line 28 "../src/Themes.vala"
		switch (0) {
#line 1237 "Themes.c"
			default:
			{
				GSettings* _tmp6_;
#line 33 "../src/Themes.vala"
				_tmp6_ = terminal_application_settings;
#line 33 "../src/Themes.vala"
				g_settings_set_boolean (_tmp6_, "prefer-dark-style", FALSE);
#line 34 "../src/Themes.vala"
				break;
#line 1247 "Themes.c"
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string (TERMINAL_THEMES_DARK)))) {
#line 28 "../src/Themes.vala"
		switch (0) {
#line 1253 "Themes.c"
			default:
			{
				GSettings* _tmp7_;
#line 36 "../src/Themes.vala"
				_tmp7_ = terminal_application_settings;
#line 36 "../src/Themes.vala"
				g_settings_set_boolean (_tmp7_, "prefer-dark-style", TRUE);
#line 37 "../src/Themes.vala"
				break;
#line 1263 "Themes.c"
			}
		}
	}
}

static void
__terminal_themes___lambda4__g_settings_changed (GSettings* _sender,
                                                 const gchar* key,
                                                 gpointer self)
{
#line 27 "../src/Themes.vala"
	_terminal_themes___lambda4_ ();
#line 1276 "Themes.c"
}

static void
terminal_value_themes_init (GValue* value)
{
#line 19 "../src/Themes.vala"
	value->data[0].v_pointer = NULL;
#line 1284 "Themes.c"
}

static void
terminal_value_themes_free_value (GValue* value)
{
#line 19 "../src/Themes.vala"
	if (value->data[0].v_pointer) {
#line 19 "../src/Themes.vala"
		terminal_themes_unref (value->data[0].v_pointer);
#line 1294 "Themes.c"
	}
}

static void
terminal_value_themes_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
#line 19 "../src/Themes.vala"
	if (src_value->data[0].v_pointer) {
#line 19 "../src/Themes.vala"
		dest_value->data[0].v_pointer = terminal_themes_ref (src_value->data[0].v_pointer);
#line 1306 "Themes.c"
	} else {
#line 19 "../src/Themes.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1310 "Themes.c"
	}
}

static gpointer
terminal_value_themes_peek_pointer (const GValue* value)
{
#line 19 "../src/Themes.vala"
	return value->data[0].v_pointer;
#line 1319 "Themes.c"
}

static gchar*
terminal_value_themes_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
#line 19 "../src/Themes.vala"
	if (collect_values[0].v_pointer) {
#line 1330 "Themes.c"
		TerminalThemes * object;
		object = collect_values[0].v_pointer;
#line 19 "../src/Themes.vala"
		if (object->parent_instance.g_class == NULL) {
#line 19 "../src/Themes.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1337 "Themes.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 19 "../src/Themes.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1341 "Themes.c"
		}
#line 19 "../src/Themes.vala"
		value->data[0].v_pointer = terminal_themes_ref (object);
#line 1345 "Themes.c"
	} else {
#line 19 "../src/Themes.vala"
		value->data[0].v_pointer = NULL;
#line 1349 "Themes.c"
	}
#line 19 "../src/Themes.vala"
	return NULL;
#line 1353 "Themes.c"
}

static gchar*
terminal_value_themes_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	TerminalThemes ** object_p;
	object_p = collect_values[0].v_pointer;
#line 19 "../src/Themes.vala"
	if (!object_p) {
#line 19 "../src/Themes.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1368 "Themes.c"
	}
#line 19 "../src/Themes.vala"
	if (!value->data[0].v_pointer) {
#line 19 "../src/Themes.vala"
		*object_p = NULL;
#line 1374 "Themes.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 19 "../src/Themes.vala"
		*object_p = value->data[0].v_pointer;
#line 1378 "Themes.c"
	} else {
#line 19 "../src/Themes.vala"
		*object_p = terminal_themes_ref (value->data[0].v_pointer);
#line 1382 "Themes.c"
	}
#line 19 "../src/Themes.vala"
	return NULL;
#line 1386 "Themes.c"
}

GParamSpec*
terminal_param_spec_themes (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	TerminalParamSpecThemes* spec;
#line 19 "../src/Themes.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TERMINAL_TYPE_THEMES), NULL);
#line 19 "../src/Themes.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 19 "../src/Themes.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 19 "../src/Themes.vala"
	return G_PARAM_SPEC (spec);
#line 1405 "Themes.c"
}

gpointer
terminal_value_get_themes (const GValue* value)
{
#line 19 "../src/Themes.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TERMINAL_TYPE_THEMES), NULL);
#line 19 "../src/Themes.vala"
	return value->data[0].v_pointer;
#line 1415 "Themes.c"
}

void
terminal_value_set_themes (GValue* value,
                           gpointer v_object)
{
	TerminalThemes * old;
#line 19 "../src/Themes.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TERMINAL_TYPE_THEMES));
#line 19 "../src/Themes.vala"
	old = value->data[0].v_pointer;
#line 19 "../src/Themes.vala"
	if (v_object) {
#line 19 "../src/Themes.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TERMINAL_TYPE_THEMES));
#line 19 "../src/Themes.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 19 "../src/Themes.vala"
		value->data[0].v_pointer = v_object;
#line 19 "../src/Themes.vala"
		terminal_themes_ref (value->data[0].v_pointer);
#line 1437 "Themes.c"
	} else {
#line 19 "../src/Themes.vala"
		value->data[0].v_pointer = NULL;
#line 1441 "Themes.c"
	}
#line 19 "../src/Themes.vala"
	if (old) {
#line 19 "../src/Themes.vala"
		terminal_themes_unref (old);
#line 1447 "Themes.c"
	}
}

void
terminal_value_take_themes (GValue* value,
                            gpointer v_object)
{
	TerminalThemes * old;
#line 19 "../src/Themes.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TERMINAL_TYPE_THEMES));
#line 19 "../src/Themes.vala"
	old = value->data[0].v_pointer;
#line 19 "../src/Themes.vala"
	if (v_object) {
#line 19 "../src/Themes.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TERMINAL_TYPE_THEMES));
#line 19 "../src/Themes.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 19 "../src/Themes.vala"
		value->data[0].v_pointer = v_object;
#line 1468 "Themes.c"
	} else {
#line 19 "../src/Themes.vala"
		value->data[0].v_pointer = NULL;
#line 1472 "Themes.c"
	}
#line 19 "../src/Themes.vala"
	if (old) {
#line 19 "../src/Themes.vala"
		terminal_themes_unref (old);
#line 1478 "Themes.c"
	}
}

static void
terminal_themes_class_init (TerminalThemesClass * klass,
                            gpointer klass_data)
{
	GSettings* _tmp0_;
#line 19 "../src/Themes.vala"
	terminal_themes_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/Themes.vala"
	((TerminalThemesClass *) klass)->finalize = terminal_themes_finalize;
#line 27 "../src/Themes.vala"
	_tmp0_ = terminal_application_settings;
#line 27 "../src/Themes.vala"
	g_signal_connect (_tmp0_, "changed::theme", (GCallback) __terminal_themes___lambda4__g_settings_changed, NULL);
#line 1495 "Themes.c"
}

static void
terminal_themes_instance_init (TerminalThemes * self,
                               gpointer klass)
{
#line 19 "../src/Themes.vala"
	self->ref_count = 1;
#line 1504 "Themes.c"
}

static void
terminal_themes_finalize (TerminalThemes * obj)
{
	TerminalThemes * self;
#line 19 "../src/Themes.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_THEMES, TerminalThemes);
#line 19 "../src/Themes.vala"
	g_signal_handlers_destroy (self);
#line 1515 "Themes.c"
}

static GType
terminal_themes_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { terminal_value_themes_init, terminal_value_themes_free_value, terminal_value_themes_copy_value, terminal_value_themes_peek_pointer, "p", terminal_value_themes_collect_value, "p", terminal_value_themes_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TerminalThemesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_themes_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalThemes), 0, (GInstanceInitFunc) terminal_themes_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType terminal_themes_type_id;
	terminal_themes_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TerminalThemes", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return terminal_themes_type_id;
}

GType
terminal_themes_get_type (void)
{
	static volatile gsize terminal_themes_type_id__once = 0;
	if (g_once_init_enter (&terminal_themes_type_id__once)) {
		GType terminal_themes_type_id;
		terminal_themes_type_id = terminal_themes_get_type_once ();
		g_once_init_leave (&terminal_themes_type_id__once, terminal_themes_type_id);
	}
	return terminal_themes_type_id__once;
}

gpointer
terminal_themes_ref (gpointer instance)
{
	TerminalThemes * self;
	self = instance;
#line 19 "../src/Themes.vala"
	g_atomic_int_inc (&self->ref_count);
#line 19 "../src/Themes.vala"
	return instance;
#line 1550 "Themes.c"
}

void
terminal_themes_unref (gpointer instance)
{
	TerminalThemes * self;
	self = instance;
#line 19 "../src/Themes.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 19 "../src/Themes.vala"
		TERMINAL_THEMES_GET_CLASS (self)->finalize (self);
#line 19 "../src/Themes.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1564 "Themes.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

